SystemOrganization addCategory: #'Mason-Metacello'!

MetacelloCommonMCSpecLoader subclass: #MDMasonLoader
	instanceVariableNames: 'targets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Metacello'!

!MDMasonLoader class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2009 10:06'!
for: targets
	^ self new setCanvas: targets! !

!MDMasonLoader methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2009 11:25'!
load
	| repositories repoSpec repository |
	repositories := Dictionary new.
	spec resolveToLoadableSpecs packageSpecsInLoadOrder do:
		[:ea | 
		repoSpec := ea repository.
		repository := repositories
			detect: [:repo | repo name = repoSpec name]
			ifNone: [repositories at: repoSpec name put: repoSpec createRepository].
		targets version
			name: ea file;
			source: (targets mc1RepositorySource: repository)]! !

!MDMasonLoader methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2009 10:07'!
setCanvas: aTargetCanvas
	targets := aTargetCanvas! !

MDProduct subclass: #MDMetacelloProduct
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Metacello'!

!MDMetacelloProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2009 10:00'!
on: aProject
	^ self new setProject: aProject
	! !

!MDMetacelloProduct methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2009 10:00'!
setProject: aProject
	project := aProject! !

!MDMetacelloProduct methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2009 10:09'!
specifyOn: targets
	project loader: (MDMasonLoader for: targets).
	project load! !
